# example.js

``` javascript
function getTemplate(templateName) {
	return require("./templates/"+templateName);
}
console.log(getTemplate("a"));
console.log(getTemplate("b"));
```

# templates/

* a.js
* b.js
* c.js

All templates are of this pattern:

``` javascript
module.exports = function() {
	return "This text was generated by template X";
}
```

# js/output.js

<details><summary>`/******/ (function(modules) { /* webpackBootstrap */ })`</summary>
``` javascript
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.l = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };

/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};

/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};

/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "js/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
```
</details>
``` javascript
/******/ ([
/* 0 */
/* unknown exports provided */
/* all exports used */
/*!************************!*\
  !*** ./templates/a.js ***!
  \************************/
/***/ function(module, exports) {

module.exports = function() {
	return "This text was generated by template A";
}

/***/ },
/* 1 */
/* unknown exports provided */
/* all exports used */
/*!************************!*\
  !*** ./templates/b.js ***!
  \************************/
/***/ function(module, exports) {

module.exports = function() {
	return "This text was generated by template B";
}

/***/ },
/* 2 */
/* unknown exports provided */
/* all exports used */
/*!************************!*\
  !*** ./templates/c.js ***!
  \************************/
/***/ function(module, exports) {

module.exports = function() {
	return "This text was generated by template C";
}

/***/ },
/* 3 */
/* unknown exports provided */
/* all exports used */
/*!****************************!*\
  !*** ./templates ^\.\/.*$ ***!
  \****************************/
/***/ function(module, exports, __webpack_require__) {

var map = {
	"./a": 0,
	"./a.js": 0,
	"./b": 1,
	"./b.js": 1,
	"./c": 2,
	"./c.js": 2
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 3;


/***/ },
/* 4 */
/* unknown exports provided */
/* all exports used */
/*!********************!*\
  !*** ./example.js ***!
  \********************/
/***/ function(module, exports, __webpack_require__) {

function getTemplate(templateName) {
	return __webpack_require__(/*! ./templates */ 3)("./"+templateName);
}
console.log(getTemplate("a"));
console.log(getTemplate("b"));

/***/ }
/******/ ]);
```

# Info

## Uncompressed

```
Hash: 434f1ff7c7a1ef6454f5
Version: webpack 2.1.0-beta.25
Time: 121ms
    Asset     Size  Chunks             Chunk Names
output.js  4.35 kB       0  [emitted]  main
Entrypoint main = output.js
chunk    {0} output.js (main) 603 bytes [entry] [rendered]
    > main [4] ./example.js 
    [0] ./templates/a.js 80 bytes {0} [optional] [built]
        context element ./a [3] ./templates ^\.\/.*$
        context element ./a.js [3] ./templates ^\.\/.*$
    [1] ./templates/b.js 80 bytes {0} [optional] [built]
        context element ./b [3] ./templates ^\.\/.*$
        context element ./b.js [3] ./templates ^\.\/.*$
    [2] ./templates/c.js 80 bytes {0} [optional] [built]
        context element ./c [3] ./templates ^\.\/.*$
        context element ./c.js [3] ./templates ^\.\/.*$
    [3] ./templates ^\.\/.*$ 217 bytes {0} [built]
        cjs require context ./templates [4] ./example.js 2:8-44
    [4] ./example.js 146 bytes {0} [built]
```

## Minimized (uglify-js, no zip)

```
Hash: 434f1ff7c7a1ef6454f5
Version: webpack 2.1.0-beta.25
Time: 236ms
    Asset    Size  Chunks             Chunk Names
output.js  1.1 kB       0  [emitted]  main
Entrypoint main = output.js
chunk    {0} output.js (main) 603 bytes [entry] [rendered]
    > main [4] ./example.js 
    [0] ./templates/a.js 80 bytes {0} [optional] [built]
        context element ./a [3] ./templates ^\.\/.*$
        context element ./a.js [3] ./templates ^\.\/.*$
    [1] ./templates/b.js 80 bytes {0} [optional] [built]
        context element ./b [3] ./templates ^\.\/.*$
        context element ./b.js [3] ./templates ^\.\/.*$
    [2] ./templates/c.js 80 bytes {0} [optional] [built]
        context element ./c [3] ./templates ^\.\/.*$
        context element ./c.js [3] ./templates ^\.\/.*$
    [3] ./templates ^\.\/.*$ 217 bytes {0} [built]
        cjs require context ./templates [4] ./example.js 2:8-44
    [4] ./example.js 146 bytes {0} [built]
```

# Code Splitting

See [this example combined with code splitting](../code-splitted-require.context)
